%  Tout travail avec MATLAB seffectue dans un fichier .m
% Slectionner les lignes  excuter et taper F9 (evaluate selection)

var1=3.14
myString='hello world'
pi
a = 10
c = 10*-2*a
nom = 'Roger';

% Modifier le format d'affichage des nombres
format long   	% Notation 15 Chiffres
format short
%-----------------------------------------------------------------------------------
%                    REPERTOIRE DE TRAVAIL
%-----------------------------------------------------------------------------------
% Pour connaitre le rpertoire de travail :
pwd
%Pour changer de rpertoire, utiliser la commande cd:

%-----------------------------------------------------------------------------------
%                 	OPERATIONS SCALAIRES DE BASE
%-----------------------------------------------------------------------------------
%Oprations de base (+,?,*,/)
7/45
(1+i)*(2+i)
1 / 0
0 / 0

%Exposants (^)
4^2
(3+4*j)^2

%Priorit des oprations + parenthses
((2+3)*3)^0.1

%Pas de multiplication implicite!!
%3(1+0.7) % il y aura un message derreur!!

%Commande pour rinitialiser la fentre de commande
clc

%Fonctions Prprogrammes
sqrt(2)
log(2)         	% Logarithme Nprien ln
log10(0.23)     % Logarithme Dcimal
cos(1.2)
atan(-0.8)
exp(2+4*i)
round(1.6)     	% Arrondi
floor(3.7)      % Partie Entire
ceil(4.23)     	% Arrondi Suprieur

angle(i)        
abs(1+i)        % Valeur Absolue ou Module d'un Complexe

%Informations sur lutilisation dune commande:
help sin

%Pour une documentation plus complte:
doc sin 
%-----------------------------------------------------------------------------------
%                    		MATRICES
%-----------------------------------------------------------------------------------

% Vecteurs
row=[1 2 5.4 -6.6]
row = [1, 2, 5.4, -6.6]
column = [4;2;7;4]

% Matrice
A= [1 2;3 4]

% Transposition
B=transpose(a)
C=A.'

%Sans le point: transposition Hermitienne, 
%i.e. transposition + conjugu
%complexe
H = [1+j 2+3*j]
H'
H.'

% oprations lment par lment
A=[1 2 3];B=[4;2;1];
%A.*B        %  erreur!!
%A./B        %  erreur!!
%A.^B        %  erreur!!
A.*B'       %  Ok!!
A./B'       %  Ok!!
A.^(B')     %  Ok!!

%-----------------------------------------------------------------------------------
%                   	 	POLYNOMES 
%-----------------------------------------------------------------------------------

% P(x) = 3x^2-5x+2, il sera represente par le vecteur P:
P = [3 -5 2]

% Pour Evaluer le polynome, on utilise la fonction polyval. 
% Pour calculer P(5) :
polyval(P,5)

% Calcul des Racines d'un Polynome
racines = roots(P)

% La fonction poly permet de crer un polynome 
%  partir de ses racines:
P3 = poly([1 -1])

% Trac Polynome
P=[1, 0, -1]
x=-3:0.1:3
TRACE=polyval(P,x)
plot(x, TRACE)

%-----------------------------------------------------------------------------------
%                    FONCTIONS DINITIALISATION
%-----------------------------------------------------------------------------------
o=ones(1,10) 	% vecteur ligne avec 10 lments tous gaux  1
o=ones(2,10) 	% Matrice 2 colonnes *10 lignes avec lments %tous gaux  1
z=zeros(23,1) 	% vecteur colonne avec 23 lments
% tous gaux  0
r=rand(1,45) 	% vecteur ligne g avec 10 
% lments alatoires compris entre 0 et 1
%Pour initialiser une squence linaire: linspace
a=linspace(0,10,5) % dbut  0, fin  10 (inclus), 5 valeurs

%On peut aussi utiliser la technique suivante :
b=0:2:10; %?dbut  0, par incrment de 2, fin  10
c=1:5 %?dans ce cas, Lincrment par dfaut est 1

%-----------------------------------------------------------------------------------
%                    	GRAPHIQUES 2D
%-----------------------------------------------------------------------------------

x=linspace(0,4*pi,1000);
y=sin(x);

%Valeur de y en fonction des indexes
plot(y);

%Valeur de y en fonction de x
plot(x,y);

%On peut changer la couleur, le type de point,le type de trait
plot(x, y,'b o - '); % x, y, couleur, point, type de trait
plot(x, y, 'o')

%Titres
title('sin(Theta)'); xlabel('Theta'); ylabel('sin(Theta)');

%Pour tracer deux courbes sur le mme graphique
y=sin(x);
plot(x,y);
hold on;
y=cos(x);
plot(x,y);

%Pour tracer un nouveau graphique 
%(dans lexemple, 10 est le no. de la figure)
figure(10);
plot(x, y, 'b o - ')
hold on;
plot(x,-y, 'r o - ')
%ou
figure(11);
plot(x, y, 'b o - ',x, -y, 'r o - ');

%La commande subplot permet 
%d'afficher plusieurs graphes dans une mme fentre.
x=0:0.001:10;
subplot(1,2,1);
plot(x,sin(x));
subplot(1,2,2);
plot(x,cos(x));

%Plusieurs types de graphiques 2D
x=linspace(0,4*pi,1000);
y=sin(x);
plot(x, y);         		% graphique 2D en coord. (x, y)
stem(x, y);
loglog(x, y);      	 % graphique log(y) vs log(x)
semilogx(x, y);    	 % graphique y vs log(x)
semilogy(x, y);    	 % graphique log(y) vs x
bar(x, y);         		 % graphique  barre

% Tracer la fonction 
% f(x) = e^(-|x|/(2pi))*cos(x) sur lintervale x = [-10pi 10pi].
% Utiliser une ligne rouge pleine et un nombre de points adquat.
x=-10*pi:.01:10*pi;
plot(x, exp(-abs(x)/(2*pi)).*cos(x), 'r');

%-----------------------------------------------------------------------------------
%                    ECRITURE DANS UN FICHIER
%-----------------------------------------------------------------------------------
B=0:0.001:5
fid=fopen('coeff.txt','w')  	%emplacement dans  %C:\MATLAB\WORK
fprintf(fid,'%i,\n',B')
fclose(fid)
%-----------------------------------------------------------------------------------
%                    TEST, BOUCLES, ETC..
%-----------------------------------------------------------------------------------
doc lang
%-----------------------------------------------------------------------------------
%                    FREQUENCY DOMAIN ANALYSIS
%-----------------------------------------------------------------------------------
%Dfinition dune function de Transfert
g = tf([1 0.1 7.5],[1 0.12 9 0 0])

%Trac du bode
bode(g)
bode(g,{0.1 , 100})