/*
 * File: BYPASS_cible.c
 *
 * Real-Time Workshop code generated for Simulink model BYPASS_cible.
 *
 * Model version                        : 1.186
 * Real-Time Workshop file version      : 7.6  (R2010b)  03-Aug-2010
 * Real-Time Workshop file generated on : Mon Feb 13 08:48:47 2012
 * TLC version                          : 7.6 (Jul 13 2010)
 * C/C++ source code generated on       : Mon Feb 13 08:48:48 2012
 *
 * Target selection: idelink_ert.tlc
 * Embedded hardware selection: TI C6000
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "BYPASS_cible.h"
#include "BYPASS_cible_private.h"

/* Block signals (auto storage) */

#pragma DATA_ALIGN(BYPASS_cible_B, 8)

BlockIO_BYPASS_cible BYPASS_cible_B;

/* Real-time model */
RT_MODEL_BYPASS_cible BYPASS_cible_M_;
RT_MODEL_BYPASS_cible *BYPASS_cible_M = &BYPASS_cible_M_;

/* Idle Task Block: '<Root>/Idle Task' */
void idle_num1_task_fcn(void)
{
  /* Call the system: <Root>/DSP Algorithm */
  {
    /* Output of system '<Root>/DSP Algorithm' */

    /* Output and update for function-call system: '<Root>/DSP Algorithm' */
    {
      /* local block i/o variables */
      real_T rtb_NumericalUnity[128];
      int32_T i;

      /* S-Function Block: <S2>/ADC (c6416dsk_adc) */
      {
        const real_T ADCScaleFactor = 1.0 / 32768.0;
        int_T i;
        int16_T *blkAdcBuffPtr;

        // Retrieve ADC buffer pointer and invalidate CACHE
        blkAdcBuffPtr = (int16_T *) getAdcBuff();
        CACHE_wbInvL2( (void *) blkAdcBuffPtr, 256, CACHE_WAIT );
        for (i = 0; i < 64; i++) {
          /*  Left  */
          BYPASS_cible_B.ADC[i] = (real_T)*blkAdcBuffPtr * ADCScaleFactor;

          /*  Right  */
          BYPASS_cible_B.ADC[i + 64] = (real_T)*(blkAdcBuffPtr+1) *
            ADCScaleFactor;
          blkAdcBuffPtr += 2;
        }
      }

      for (i = 0; i < 128; i++) {
        /* Switch: '<S3>/Environment Switch' incorporates:
         *  Constant: '<S3>/Switch Control'
         */
        if (BYPASS_cible_P.SwitchControl_Value_d) {
          rtb_NumericalUnity[i] = 0.0;
        } else {
          rtb_NumericalUnity[i] = BYPASS_cible_B.ADC[i];
        }

        /* Switch: '<S5>/Environment Switch' incorporates:
         *  Constant: '<S5>/Switch Control'
         *  SignalConversion: '<S5>/Numerical Unity'
         */
        if (BYPASS_cible_P.SwitchControl_Value) {
          BYPASS_cible_B.NumericalUnity[i] = 0.0;
        } else {
          BYPASS_cible_B.NumericalUnity[i] = rtb_NumericalUnity[i];
        }
      }

      /* S-Function Block: <S2>/DAC (c6416dsk_dac) */
      {
        const real_T DACScaleFactor = 32768.0;
        int_T i;
        void *blkDacBuffPtr;
        int16_T *outPtr;
        blkDacBuffPtr = getDacBuff();
        outPtr = (int16_T *) blkDacBuffPtr;
        for (i = 0; i < 64; i++) {
          /* Left */
          if (BYPASS_cible_B.NumericalUnity[i] > 0.999969482421875 )
            *outPtr = 32767;
          else if (BYPASS_cible_B.NumericalUnity[i] < -1.0 )
            *outPtr = -32768;
          else
            *outPtr = (int16_T)(BYPASS_cible_B.NumericalUnity[i] *
                                DACScaleFactor);

          /* Right */
          if (BYPASS_cible_B.NumericalUnity[i + 64] > 0.999969482421875 )
            *(outPtr+1) = 32767;
          else if (BYPASS_cible_B.NumericalUnity[i + 64] < -1.0 )
            *(outPtr+1) = -32768;
          else
            *(outPtr+1) = (int16_T)(BYPASS_cible_B.NumericalUnity[i + 64] *
              DACScaleFactor);
          outPtr += 2;
        }

        CACHE_wbL2( (void *) blkDacBuffPtr, 256, CACHE_WAIT );
      }

      /* Switch: '<S6>/Environment Switch' incorporates:
       *  Constant: '<S6>/Switch Control'
       */
      if (!BYPASS_cible_P.SwitchControl_Value_o) {
        for (i = 0; i < 128; i++) {
          rtb_NumericalUnity[i] = 0.0;
        }
      }
    }
  }
}

/* Model step function */
void BYPASS_cible_step(void)
{
  /* (no output/update code required) */
}

/* Model initialize function */
void BYPASS_cible_initialize(boolean_T firstTime)
{
  (void)firstTime;

  /* Registration code */

  /* initialize error status */
  rtmSetErrorStatus(BYPASS_cible_M, (NULL));

  /* block I/O */
  {
    int_T i;
    for (i = 0; i < 128; i++) {
      BYPASS_cible_B.ADC[i] = 0.0;
    }

    for (i = 0; i < 128; i++) {
      BYPASS_cible_B.NumericalUnity[i] = 0.0;
    }
  }

  /* Start for function-call system: '<Root>/DSP Algorithm' */

  /* S-Function Block: <S2>/ADC (c6416dsk_adc) */
  codec_init();

  /* S-Function Block: <S2>/DAC (c6416dsk_dac) */
}

/* Model terminate function */
void BYPASS_cible_terminate(void)
{
  /* (no terminate code required) */
}

/*
 * File trailer for Real-Time Workshop generated code.
 *
 * [EOF]
 */
