/*
 * File: FILTRE_FIR_cible.c
 *
 * Real-Time Workshop code generated for Simulink model FILTRE_FIR_cible.
 *
 * Model version                        : 1.199
 * Real-Time Workshop file version      : 7.6  (R2010b)  03-Aug-2010
 * Real-Time Workshop file generated on : Mon Feb 13 09:00:34 2012
 * TLC version                          : 7.6 (Jul 13 2010)
 * C/C++ source code generated on       : Mon Feb 13 09:00:35 2012
 *
 * Target selection: idelink_ert.tlc
 * Embedded hardware selection: TI C6000
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "FILTRE_FIR_cible.h"
#include "FILTRE_FIR_cible_private.h"

/* Block signals (auto storage) */

#pragma DATA_ALIGN(FILTRE_FIR_cible_B, 8)

BlockIO_FILTRE_FIR_cible FILTRE_FIR_cible_B;

/* Block states (auto storage) */
#pragma DATA_ALIGN(FILTRE_FIR_cible_DWork, 8)

D_Work_FILTRE_FIR_cible FILTRE_FIR_cible_DWork;

/* Real-time model */
RT_MODEL_FILTRE_FIR_cible FILTRE_FIR_cible_M_;
RT_MODEL_FILTRE_FIR_cible *FILTRE_FIR_cible_M = &FILTRE_FIR_cible_M_;

/* Idle Task Block: '<Root>/Idle Task' */
void idle_num1_task_fcn(void)
{
  /* Call the system: <Root>/DSP Algorithm */
  {
    /* Output of system '<Root>/DSP Algorithm' */

    /* Output and update for function-call system: '<Root>/DSP Algorithm' */
    {
      /* local block i/o variables */
      real_T rtb_NumericalUnity[128];
      real_T accum;
      real_T tapsum;
      int32_T ioIdx;
      int32_T cfIdx;
      int32_T dataIdx;
      int32_T idxN;
      int32_T j;
      int32_T k;
      int32_T memIdx;
      int32_T i;

      /* S-Function Block: <S2>/ADC (c6416dsk_adc) */
      {
        const real_T ADCScaleFactor = 1.0 / 32768.0;
        int_T i;
        int16_T *blkAdcBuffPtr;

        // Retrieve ADC buffer pointer and invalidate CACHE
        blkAdcBuffPtr = (int16_T *) getAdcBuff();
        CACHE_wbInvL2( (void *) blkAdcBuffPtr, 256, CACHE_WAIT );
        for (i = 0; i < 64; i++) {
          /*  Left  */
          FILTRE_FIR_cible_B.ADC[i] = (real_T)*blkAdcBuffPtr * ADCScaleFactor;

          /*  Right  */
          FILTRE_FIR_cible_B.ADC[i + 64] = (real_T)*(blkAdcBuffPtr+1) *
            ADCScaleFactor;
          blkAdcBuffPtr += 2;
        }
      }

      for (i = 0; i < 128; i++) {
        /* Switch: '<S3>/Environment Switch' incorporates:
         *  Constant: '<S3>/Switch Control'
         */
        if (FILTRE_FIR_cible_P.SwitchControl_Value_b) {
          rtb_NumericalUnity[i] = 0.0;
        } else {
          rtb_NumericalUnity[i] = FILTRE_FIR_cible_B.ADC[i];
        }

        /* SignalConversion: '<S3>/Numerical Unity' */
        FILTRE_FIR_cible_B.NumericalUnity[i] = rtb_NumericalUnity[i];
      }

      /* S-Function (sdspfilter2): '<S2>/Digital Filter' */
      ioIdx = 0;
      for (k = 0; k < 2; k++) {
        idxN = FILTRE_FIR_cible_DWork.DigitalFilter_CIRCBUFFIDX;
        memIdx = k << 6;
        for (i = 0; i < 64; i++) {
          dataIdx = idxN + 63;
          if (dataIdx >= 64) {
            dataIdx -= 64;
          }

          accum = (FILTRE_FIR_cible_DWork.DigitalFilter_FILT_STATES[memIdx +
                   dataIdx] + FILTRE_FIR_cible_B.NumericalUnity[ioIdx]) *
            FILTRE_FIR_cible_P.DigitalFilter_RTP1COEFF[0];
          cfIdx = 1;
          for (j = 0; j < 31; j++) {
            dataIdx = j + idxN;
            if (dataIdx >= 64) {
              dataIdx -= 64;
            }

            tapsum = FILTRE_FIR_cible_DWork.DigitalFilter_FILT_STATES[memIdx +
              dataIdx];
            dataIdx += 64 - ((j + 1) << 1);
            if (dataIdx >= 64) {
              dataIdx -= 64;
            }

            tapsum += FILTRE_FIR_cible_DWork.DigitalFilter_FILT_STATES[memIdx +
              dataIdx];
            accum += tapsum * FILTRE_FIR_cible_P.DigitalFilter_RTP1COEFF[cfIdx];
            cfIdx++;
          }

          dataIdx = j + idxN;
          if (dataIdx >= 64) {
            dataIdx -= 64;
          }

          accum += FILTRE_FIR_cible_DWork.DigitalFilter_FILT_STATES[memIdx +
            dataIdx] * FILTRE_FIR_cible_P.DigitalFilter_RTP1COEFF[cfIdx];
          idxN--;
          if (idxN < 0) {
            idxN = 63;
          }

          FILTRE_FIR_cible_DWork.DigitalFilter_FILT_STATES[memIdx + idxN] =
            FILTRE_FIR_cible_B.NumericalUnity[ioIdx];
          FILTRE_FIR_cible_B.DigitalFilter[ioIdx] = accum;
          ioIdx++;
        }
      }

      FILTRE_FIR_cible_DWork.DigitalFilter_CIRCBUFFIDX = idxN;
      for (i = 0; i < 128; i++) {
        /* Switch: '<S5>/Environment Switch' incorporates:
         *  Constant: '<S5>/Switch Control'
         */
        if (FILTRE_FIR_cible_P.SwitchControl_Value) {
          rtb_NumericalUnity[i] = 0.0;
        } else {
          rtb_NumericalUnity[i] = FILTRE_FIR_cible_B.DigitalFilter[i];
        }

        /* SignalConversion: '<S5>/Numerical Unity' */
        FILTRE_FIR_cible_B.NumericalUnity[i] = rtb_NumericalUnity[i];
      }

      /* S-Function Block: <S2>/DAC (c6416dsk_dac) */
      {
        const real_T DACScaleFactor = 32768.0;
        int_T i;
        void *blkDacBuffPtr;
        int16_T *outPtr;
        blkDacBuffPtr = getDacBuff();
        outPtr = (int16_T *) blkDacBuffPtr;
        for (i = 0; i < 64; i++) {
          /* Left */
          if (FILTRE_FIR_cible_B.NumericalUnity[i] > 0.999969482421875 )
            *outPtr = 32767;
          else if (FILTRE_FIR_cible_B.NumericalUnity[i] < -1.0 )
            *outPtr = -32768;
          else
            *outPtr = (int16_T)(FILTRE_FIR_cible_B.NumericalUnity[i] *
                                DACScaleFactor);

          /* Right */
          if (FILTRE_FIR_cible_B.NumericalUnity[i + 64] > 0.999969482421875 )
            *(outPtr+1) = 32767;
          else if (FILTRE_FIR_cible_B.NumericalUnity[i + 64] < -1.0 )
            *(outPtr+1) = -32768;
          else
            *(outPtr+1) = (int16_T)(FILTRE_FIR_cible_B.NumericalUnity[i + 64] *
              DACScaleFactor);
          outPtr += 2;
        }

        CACHE_wbL2( (void *) blkDacBuffPtr, 256, CACHE_WAIT );
      }

      /* Switch: '<S6>/Environment Switch' incorporates:
       *  Constant: '<S6>/Switch Control'
       */
      for (i = 0; i < 128; i++) {
        if (FILTRE_FIR_cible_P.SwitchControl_Value_p) {
          rtb_NumericalUnity[i] = FILTRE_FIR_cible_B.DigitalFilter[i];
        } else {
          rtb_NumericalUnity[i] = 0.0;
        }
      }
    }
  }
}

/* Model step function */
void FILTRE_FIR_cible_step(void)
{
  /* (no output/update code required) */
}

/* Model initialize function */
void FILTRE_FIR_cible_initialize(boolean_T firstTime)
{
  (void)firstTime;

  /* Registration code */

  /* initialize error status */
  rtmSetErrorStatus(FILTRE_FIR_cible_M, (NULL));

  /* block I/O */
  {
    int_T i;
    for (i = 0; i < 128; i++) {
      FILTRE_FIR_cible_B.ADC[i] = 0.0;
    }

    for (i = 0; i < 128; i++) {
      FILTRE_FIR_cible_B.DigitalFilter[i] = 0.0;
    }

    for (i = 0; i < 128; i++) {
      FILTRE_FIR_cible_B.NumericalUnity[i] = 0.0;
    }
  }

  /* states (dwork) */
  (void) memset((void *)&FILTRE_FIR_cible_DWork, 0,
                sizeof(D_Work_FILTRE_FIR_cible));

  {
    int_T i;
    for (i = 0; i < 128; i++) {
      FILTRE_FIR_cible_DWork.DigitalFilter_FILT_STATES[i] = 0.0;
    }
  }

  /* Start for function-call system: '<Root>/DSP Algorithm' */

  /* S-Function Block: <S2>/ADC (c6416dsk_adc) */
  codec_init();

  /* S-Function Block: <S2>/DAC (c6416dsk_dac) */
}

/* Model terminate function */
void FILTRE_FIR_cible_terminate(void)
{
  /* (no terminate code required) */
}

/*
 * File trailer for Real-Time Workshop generated code.
 *
 * [EOF]
 */
