/*
 * File: REVERB_cible.c
 *
 * Real-Time Workshop code generated for Simulink model REVERB_cible.
 *
 * Model version                        : 1.191
 * Real-Time Workshop file version      : 7.6  (R2010b)  03-Aug-2010
 * Real-Time Workshop file generated on : Mon Feb 13 08:52:48 2012
 * TLC version                          : 7.6 (Jul 13 2010)
 * C/C++ source code generated on       : Mon Feb 13 08:52:49 2012
 *
 * Target selection: idelink_ert.tlc
 * Embedded hardware selection: TI C6000
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "REVERB_cible.h"
#include "REVERB_cible_private.h"

/* Block signals (auto storage) */

#pragma DATA_ALIGN(REVERB_cible_B, 8)

BlockIO_REVERB_cible REVERB_cible_B;

/* Block states (auto storage) */
#pragma DATA_ALIGN(REVERB_cible_DWork, 8)

D_Work_REVERB_cible REVERB_cible_DWork;

/* Real-time model */
RT_MODEL_REVERB_cible REVERB_cible_M_;
RT_MODEL_REVERB_cible *REVERB_cible_M = &REVERB_cible_M_;

/* Idle Task Block: '<Root>/Idle Task' */
void idle_num1_task_fcn(void)
{
  /* Call the system: <Root>/DSP Algorithm */
  {
    /* Output of system '<Root>/DSP Algorithm' */

    /* Output and update for function-call system: '<Root>/DSP Algorithm' */
    {
      /* local block i/o variables */
      real_T rtb_NumericalUnity_a[128];
      int32_T buffStart;
      int32_T copy1Size;
      int32_T copy2Size;
      uint32_T copy1Bytes;
      uint32_T copy2Bytes;
      int32_T iDest;
      int32_T channelOffset;
      int32_T iChan;
      real_T rtb_DelayMix[128];
      real_T rtb_NumericalUnity[128];
      real_T rtb_NumericalUnity_0;

      /* S-Function (sdspdelay): '<S2>/Integer Delay' */
      buffStart = REVERB_cible_DWork.IntegerDelay_CIRC_BUF_IDX % 2400;
      if (buffStart <= 2336) {
        copy1Size = 64;
        copy2Size = 0;
      } else {
        copy1Size = 2400 - buffStart;
        copy2Size = 64 - copy1Size;
      }

      copy1Bytes = (uint32_T)(copy1Size * (int32_T)MWDSP_SIZEOF_DOUBLE);
      copy2Bytes = (uint32_T)(copy2Size * (int32_T)MWDSP_SIZEOF_DOUBLE);
      iDest = 0;
      channelOffset = 0;
      for (iChan = 0; iChan < 2; iChan++) {
        memcpy(&REVERB_cible_B.IntegerDelay[iDest],
               &REVERB_cible_DWork.IntegerDelay_IC_BUFF[buffStart +
               channelOffset], copy1Bytes);
        iDest += copy1Size;
        memcpy(&REVERB_cible_B.IntegerDelay[iDest],
               &REVERB_cible_DWork.IntegerDelay_IC_BUFF[channelOffset],
               copy2Bytes);
        iDest += copy2Size;
        channelOffset += 2400;
      }

      /* Gain: '<S2>/Delay Mix' */
      for (buffStart = 0; buffStart < 128; buffStart++) {
        rtb_DelayMix[buffStart] = REVERB_cible_P.DelayMix_Gain *
          REVERB_cible_B.IntegerDelay[buffStart];
      }

      /* S-Function Block: <S2>/ADC (c6416dsk_adc) */
      {
        const real_T ADCScaleFactor = 1.0 / 32768.0;
        int_T i;
        int16_T *blkAdcBuffPtr;

        // Retrieve ADC buffer pointer and invalidate CACHE
        blkAdcBuffPtr = (int16_T *) getAdcBuff();
        CACHE_wbInvL2( (void *) blkAdcBuffPtr, 256, CACHE_WAIT );
        for (i = 0; i < 64; i++) {
          /*  Left  */
          REVERB_cible_B.ADC[i] = (real_T)*blkAdcBuffPtr * ADCScaleFactor;

          /*  Right  */
          REVERB_cible_B.ADC[i + 64] = (real_T)*(blkAdcBuffPtr+1) *
            ADCScaleFactor;
          blkAdcBuffPtr += 2;
        }
      }

      for (buffStart = 0; buffStart < 128; buffStart++) {
        /* Switch: '<S3>/Environment Switch' incorporates:
         *  Constant: '<S3>/Switch Control'
         */
        if (REVERB_cible_P.SwitchControl_Value_e) {
          rtb_NumericalUnity_0 = 0.0;
        } else {
          rtb_NumericalUnity_0 = REVERB_cible_B.ADC[buffStart];
        }

        /* Sum: '<S2>/Sum3' */
        rtb_NumericalUnity_a[buffStart] = rtb_DelayMix[buffStart] +
          rtb_NumericalUnity_0;

        /* Switch: '<S5>/Environment Switch' incorporates:
         *  Constant: '<S5>/Switch Control'
         *  SignalConversion: '<S5>/Numerical Unity'
         */
        if (REVERB_cible_P.SwitchControl_Value) {
          REVERB_cible_B.NumericalUnity[buffStart] = 0.0;
        } else {
          REVERB_cible_B.NumericalUnity[buffStart] =
            rtb_NumericalUnity_a[buffStart];
        }

        rtb_NumericalUnity[buffStart] = rtb_NumericalUnity_0;
      }

      /* S-Function Block: <S2>/DAC (c6416dsk_dac) */
      {
        const real_T DACScaleFactor = 32768.0;
        int_T i;
        void *blkDacBuffPtr;
        int16_T *outPtr;
        blkDacBuffPtr = getDacBuff();
        outPtr = (int16_T *) blkDacBuffPtr;
        for (i = 0; i < 64; i++) {
          /* Left */
          if (REVERB_cible_B.NumericalUnity[i] > 0.999969482421875 )
            *outPtr = 32767;
          else if (REVERB_cible_B.NumericalUnity[i] < -1.0 )
            *outPtr = -32768;
          else
            *outPtr = (int16_T)(REVERB_cible_B.NumericalUnity[i] *
                                DACScaleFactor);

          /* Right */
          if (REVERB_cible_B.NumericalUnity[i + 64] > 0.999969482421875 )
            *(outPtr+1) = 32767;
          else if (REVERB_cible_B.NumericalUnity[i + 64] < -1.0 )
            *(outPtr+1) = -32768;
          else
            *(outPtr+1) = (int16_T)(REVERB_cible_B.NumericalUnity[i + 64] *
              DACScaleFactor);
          outPtr += 2;
        }

        CACHE_wbL2( (void *) blkDacBuffPtr, 256, CACHE_WAIT );
      }

      /* Gain: '<S2>/Feedback Gain' */
      for (buffStart = 0; buffStart < 128; buffStart++) {
        rtb_DelayMix[buffStart] = REVERB_cible_P.FeedbackGain_Gain *
          REVERB_cible_B.IntegerDelay[buffStart];
      }

      /* Switch: '<S6>/Environment Switch' incorporates:
       *  Constant: '<S6>/Switch Control'
       */
      if (!REVERB_cible_P.SwitchControl_Value_a) {
        for (buffStart = 0; buffStart < 128; buffStart++) {
          rtb_NumericalUnity_a[buffStart] = 0.0;
        }
      }

      /* Sum: '<S2>/Sum2' */
      for (buffStart = 0; buffStart < 128; buffStart++) {
        REVERB_cible_B.Sum2[buffStart] = rtb_DelayMix[buffStart] +
          rtb_NumericalUnity[buffStart];
      }

      /* Update for S-Function (sdspdelay): '<S2>/Integer Delay' */
      buffStart = REVERB_cible_DWork.IntegerDelay_CIRC_BUF_IDX % 2400;
      if (buffStart <= 2336) {
        copy1Size = 64;
        copy2Size = 0;
      } else {
        copy1Size = 2400 - buffStart;
        copy2Size = 64 - copy1Size;
      }

      copy1Bytes = (uint32_T)(copy1Size * (int32_T)MWDSP_SIZEOF_DOUBLE);
      copy2Bytes = (uint32_T)(copy2Size * (int32_T)MWDSP_SIZEOF_DOUBLE);
      iDest = 0;
      channelOffset = 0;
      for (iChan = 0; iChan < 2; iChan++) {
        memcpy(&REVERB_cible_DWork.IntegerDelay_IC_BUFF[buffStart +
               channelOffset], &REVERB_cible_B.Sum2[iDest], copy1Bytes);
        iDest += copy1Size;
        memcpy(&REVERB_cible_DWork.IntegerDelay_IC_BUFF[channelOffset],
               &REVERB_cible_B.Sum2[iDest], copy2Bytes);
        iDest += copy2Size;
        channelOffset += 2400;
      }

      REVERB_cible_DWork.IntegerDelay_CIRC_BUF_IDX = buffStart + 64;
    }
  }
}

/* Model step function */
void REVERB_cible_step(void)
{
  /* (no output/update code required) */
}

/* Model initialize function */
void REVERB_cible_initialize(boolean_T firstTime)
{
  (void)firstTime;

  /* Registration code */

  /* initialize error status */
  rtmSetErrorStatus(REVERB_cible_M, (NULL));

  /* block I/O */
  {
    int_T i;
    for (i = 0; i < 128; i++) {
      REVERB_cible_B.ADC[i] = 0.0;
    }

    for (i = 0; i < 128; i++) {
      REVERB_cible_B.Sum2[i] = 0.0;
    }

    for (i = 0; i < 128; i++) {
      REVERB_cible_B.NumericalUnity[i] = 0.0;
    }
  }

  /* states (dwork) */
  (void) memset((void *)&REVERB_cible_DWork, 0,
                sizeof(D_Work_REVERB_cible));

  {
    int_T i;
    for (i = 0; i < 4800; i++) {
      REVERB_cible_DWork.IntegerDelay_IC_BUFF[i] = 0.0;
    }
  }

  /* Start for function-call system: '<Root>/DSP Algorithm' */

  /* S-Function Block: <S2>/ADC (c6416dsk_adc) */
  codec_init();

  /* S-Function Block: <S2>/DAC (c6416dsk_dac) */
}

/* Model terminate function */
void REVERB_cible_terminate(void)
{
  /* (no terminate code required) */
}

/*
 * File trailer for Real-Time Workshop generated code.
 *
 * [EOF]
 */
