;FIRcircfunc.asm ASM function called from C using circular addressing
;A4=newest sample, B4=coefficient address, A6=filter order 
;Delay samples organized: x[n-(N-1)]...x[n]; coeff as h(0)...h[N-1]

            .def  _fir_circ_opt
            .def   last_addr 
            .def   delays  
	      .sect "circdata"   ;circular data section
            .align 256         ;align delay buffer 256-byte boundary
delays      .space 256         ;init 256-byte buffer with 0's
last_addr   .int   last_addr-1 ;point to bottom of delays buffer
            .text		       ;code section
_fir_circ_opt:			 ;FIR function using circ addr                    
            MV    A6,A1    	 ;setup loop count 
 	      	MPY   A6,2,A6      ;since dly buffer data as byte
	     	ZERO  A8   	       ;init A8 for accumulation				   		
	     	ADD   A6,B4,B4	 ;since coeff buffer data as bytes
	      	SUB   B4,1,B4      ;B4=bottom coeff array h[N-1] 
    
            MVKL 0x00070040,B6 ;select A7 as pointer and BK0
            MVKH 0x00070040,B6 ;BK0 for 256 bytes (128 shorts) 
       
            MVC   B6,AMR       ;set address mode register AMR		

	      	MVK  last_addr,A9  ;A9=last circ addr(lower 16 bits)
	      	MVKH last_addr,A9  ;last circ addr (higher 16 bits)      			
            LDW   *A9,A7       ;A7=last circ addr
            NOP   4
            MV	  A7,A14	; On garde en mmoire A7 
            STH   A4,*A7++	 ;newest sample-->last address
			NOP	  5

 ;1			
		   LDH .D1 *A7++,A2 ; load ai		;1
		|| LDH .D2 *B4--,B2 ; load bi
		|| ZERO .L1 A5 ; zero out sum0 accumulator
		|| ZERO .L2 B7 ; zero out sum1 accumulator
;2	 
	  [A1] SUB .S1 A1,1,A1 ; decrement loop counter				;2
		|| LDH .D1 *A7++,A2 ; load ai 		;1
		|| LDH .D2 *B4--,B2 ; load bi 
;3	 
	  [A1] SUB .S1 A1,1,A1 ;* decrement loop counter			;3
		||[A1] B .S2 LOOP ; branch to loop
		|| LDH .D1 *A7++,A2 ; load ai		;1
		|| LDH .D2 *B4--,B2 ; load bi
;4	 
	  [A1] SUB .S1 A1,1,A1 ;** decrement loop counter			;4
		||[A1] B .S2 LOOP ;* branch to loop
		|| LDH .D1 *A7++,A2 ; load ai 		;1
		|| LDH .D2 *B4--,B2 ; load bi
;5	 
	  [A1] SUB .S1 A1,1,A1 ;*** decrement loop counter			;5
		||[A1] B .S2 LOOP ;** branch to loop
		|| LDH .D1 *A7++,A2 ; load ai		;1
		|| LDH .D2 *B4--,B2 ; load bi
;6	
		   MPY .M1X A2,B2,A6 ; ai * bi							;6
     ||[A1] SUB .S1 A1,1,A1 ;**** decrement loop counter
		||[A1] B .S2 LOOP ;*** branch to loop
		|| LDH .D1 *A7++,A2 ; load ai		;1
		|| LDH .D2 *B4--,B2 ; load bi
;7	
			MPY .M1X A2,B2,A6 ;* ai * bi						;7
		||[A1] SUB .S1 A1,1,A1 ;***** decrement loop counter
		||[A1] B .S2 LOOP ;**** branch to loop
		|| LDH .D1 *A7++,A2 ; load ai 		;1
		|| LDH .D2 *B4--,B2 ; load bi 
;8	
LOOP:		;Piped Loop Kernel

		[A1] ADD .L1 A6,A8,A8 ; sum0 += (ai * bi)				;8
		|| MPY .M1X A2,B2,A6 ;** ai * bi
		||[A1] SUB .S1 A1,1,A1 ;****** decrement loop counter
		||[A1] B .S2 LOOP ;***** branch to loop
		||[A1] LDH .D1 *A7++,A2 ; load ai 		;1
		||[A1] LDH .D2 *B4--,B2 ; load bi 
		; Branch occurs here
		
			
			MV	  A14,A7
      		LDH   *A7++,A2     ;just to increment A7

            STW   A7,*A9	 ;store last circ addr to last_addr
            B     B3           ;return addr to calling routine
            MV    A8,A4	       ;result returned in A4
            NOP   4
