
%***********************************************************
% GENERATION DE COEFFICIENTS POUR FILTRE FIR
%-----------------------------------------------------------
% TSN - LABOS DSP
% kerhoas@enib.fr
%***********************************************************
N=128;                  		%Ordre du Filtre
Fe=24000						%Frquence d'chantillonage 
We=2*pi*Fe

Fc=5000;						%Frquence de Coupure
Wc=2*pi*Fc

Wn=Wc/(We/2);           		%Frquence normalise


B=fir1(N,Wn,'low')      		%Calcul des coefficients 
								% d'un filtre FIR 
C=B(1,1:N)

freqz(C)
max(C)
min(C)

C_entier=round(C*2^15)

fid=fopen('coeff_entiers.txt','w')  %emplacement  vrifier avec pwd
fprintf(fid,'%i,\n',C_entier')
fclose(fid)

fid=fopen('coefficients.txt','w')
fprintf(fid,'%6.12f,\n ',C')
fclose(fid)

%-----------------------------------------------------------
% Calcul d'un passe bande / Coupe Bande
%-----------------------------------------------------------

N=128;						%Ordre du Filtre
Fe=24000					%Frquence d'chantillonage
We=2*pi*Fe

Fc1=1000;					%Frquence de Coupure
Fc2=3000;
Wc1=2*pi*Fc1
Wc2=2*pi*Fc2

Wn=[Wc1,Wc2]/(We/2);		%Frquence normalise


B=fir1(N,Wn,'low')	
C=B(1,1:N)

freqz(C)

max(C)

C_entier=round(C*2^15)

fid=fopen('coeff_entiers.txt','w') 
fprintf(fid,'%i,\n',C_entier')
fclose(fid)